###########################################################################
###  HTML cleaning tags for MT - 25 Sep 2002
###  l.m.orchard <deus_x@pobox.com> http://www.decafbad.com
###
###    Code shamelessly borrowed from LiveJournal's cgi-bin/cleanhtml.pl
### 
###    <MTCleanHTMLComment> - Clean javascript and close tags in 
###        HTML comments
###    <MTCleanHTMLSubject> - Used for shorter bits of text (ie. subjects)
###
###  This software is provided as-is.
###  You may use it for commercial or personal use.
###  If you distribute it, please keep this notice intact.
###
###  Copyright (c) 2002 l.m.orchard
###########################################################################

no warnings;
use strict;

use MT::Template::Context;
use MT::decafbad::cleanhtml;

MT::Template::Context->add_container_tag(CleanHTMLComment => \&doCleanComment);
MT::Template::Context->add_container_tag(CleanHTMLSubject => \&doCleanSubject);

sub doCleanComment {
    my ($ctx, $args) = @_;
    my $raw = _buildChildTags($ctx);
    return MT::decafbad::cleanhtml::clean_comment(\$raw, 1);
}

sub doCleanSubject {
    my ($ctx, $args) = @_;
    my $raw = _buildChildTags($ctx);
    return MT::decafbad::cleanhtml::clean_subject(\$raw, 1);
}

sub _buildChildTags {
  my ($ctx) = @_;

  ### Build out any child tags.
  my $tokens = $ctx->stash('tokens');
  my $builder = $ctx->stash('builder');
  defined(my $raw = $builder->build($ctx, $tokens))
    or return $ctx->error($builder->errstr);

  return $raw;
}
